package dev.shadowsoffire.apotheosis.ench.table;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.advancements.EnchantedTrigger;
import dev.shadowsoffire.apotheosis.ench.Ench;
import dev.shadowsoffire.apotheosis.ench.api.IEnchantingBlock;
import dev.shadowsoffire.apotheosis.ench.table.ApothEnchantTile;
import dev.shadowsoffire.apotheosis.ench.table.ClueMessage;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingRecipe;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry;
import dev.shadowsoffire.apotheosis.ench.table.IEnchantableItem;
import dev.shadowsoffire.apotheosis.ench.table.RealEnchantmentHelper;
import dev.shadowsoffire.apotheosis.ench.table.StatsMessage;
import dev.shadowsoffire.apotheosis.util.ApothMiscUtil;
import dev.shadowsoffire.placebo.network.PacketDistro;
import dev.shadowsoffire.placebo.util.EnchantmentUtils;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.Optional;
import net.minecraft.advancements.CriteriaTriggers;
import net.minecraft.core.BlockPos;
import net.minecraft.core.Vec3i;
import net.minecraft.core.registries.BuiltInRegistries;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.sounds.SoundSource;
import net.minecraft.stats.Stats;
import net.minecraft.tags.BlockTags;
import net.minecraft.world.Container;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.ContainerLevelAccess;
import net.minecraft.world.inventory.EnchantmentMenu;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraft.world.item.enchantment.EnchantmentInstance;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.block.EnchantmentTableBlock;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraftforge.event.ForgeEventFactory;
import net.minecraftforge.items.IItemHandler;

public class ApothEnchantmentMenu extends EnchantmentMenu {
  protected TableStats stats = TableStats.INVALID;
  
  protected final Player player;
  
  public ApothEnchantmentMenu(int id, Inventory inv) {
    super(id, inv, ContainerLevelAccess.f_39287_);
    this.player = inv.f_35978_;
    this.f_38839_.clear();
    addSecretSlot((Slot)new Object(this, this.f_39449_, 0, 15, 47));
    addSecretSlot((Slot)new Object(this, this.f_39449_, 1, 35, 47));
    initCommon(inv);
  }
  
  public ApothEnchantmentMenu(int id, Inventory inv, ContainerLevelAccess wPos, ApothEnchantTile te) {
    super(id, inv, wPos);
    this.player = inv.f_35978_;
    this.f_38839_.clear();
    addSecretSlot((Slot)new Object(this, this.f_39449_, 0, 15, 47));
    addSecretSlot((Slot)new Object(this, (IItemHandler)te.inv, 0, 35, 47));
    initCommon(inv);
  }
  
  protected Slot addSecretSlot(Slot pSlot) {
    pSlot.f_40219_ = this.f_38839_.size();
    this.f_38839_.add(pSlot);
    return pSlot;
  }
  
  private void initCommon(Inventory inv) {
    for (int i = 0; i < 3; i++) {
      for (int j = 0; j < 9; j++)
        addSecretSlot(new Slot((Container)inv, j + i * 9 + 9, 8 + j * 18, 84 + i * 18 + 31)); 
    } 
    for (int k = 0; k < 9; k++)
      addSecretSlot(new Slot((Container)inv, k, 8 + k * 18, 173)); 
  }
  
  public boolean m_6366_(Player player, int id) {
    int slot = id;
    int level = this.f_39446_[slot];
    ItemStack toEnchant = this.f_39449_.m_8020_(0);
    ItemStack lapis = m_38853_(1).m_7993_();
    int cost = slot + 1;
    if ((lapis.m_41619_() || lapis.m_41613_() < cost) && !(player.m_150110_()).f_35937_)
      return false; 
    if (this.f_39446_[slot] <= 0 || toEnchant.m_41619_() || ((player.f_36078_ < cost || player.f_36078_ < this.f_39446_[slot]) && !(player.m_150110_()).f_35937_))
      return false; 
    this.f_39450_.m_39292_((world, pos) -> {
          ItemStack enchanted = toEnchant;
          float eterna = this.stats.eterna;
          float quanta = this.stats.quanta;
          float arcana = this.stats.arcana;
          float rectification = this.stats.rectification;
          List<EnchantmentInstance> list = m_39471_(toEnchant, slot, this.f_39446_[slot]);
          if (!list.isEmpty()) {
            EnchantmentUtils.chargeExperience(player, ApothMiscUtil.getExpCostForSlot(level, slot));
            player.m_7408_(toEnchant, 0);
            if (((EnchantmentInstance)list.get(0)).f_44947_ == Ench.Enchantments.INFUSION.get()) {
              EnchantingRecipe match = EnchantingRecipe.findMatch(world, toEnchant, eterna, quanta, arcana);
              if (match != null) {
                this.f_39449_.m_6836_(0, match.assemble(toEnchant, eterna, quanta, arcana));
              } else {
                return;
              } 
            } else {
              this.f_39449_.m_6836_(0, ((IEnchantableItem)toEnchant.m_41720_()).onEnchantment(toEnchant, list));
            } 
            if (!(player.m_150110_()).f_35937_) {
              lapis.m_41774_(cost);
              if (lapis.m_41619_())
                this.f_39449_.m_6836_(1, ItemStack.f_41583_); 
            } 
            player.m_36220_(Stats.f_12964_);
            if (player instanceof ServerPlayer)
              ((EnchantedTrigger)CriteriaTriggers.f_10575_).trigger((ServerPlayer)player, enchanted, level, eterna, quanta, arcana, rectification); 
            this.f_39449_.m_6596_();
            this.f_39452_.m_6422_(player.m_36322_());
            m_6199_(this.f_39449_);
            world.m_5594_((Player)null, pos, SoundEvents.f_11887_, SoundSource.BLOCKS, 1.0F, world.f_46441_.m_188501_() * 0.1F + 0.9F);
          } 
        });
    return true;
  }
  
  public void m_6199_(Container inventoryIn) {
    this.f_39450_.m_6721_((world, pos) -> {
          if (inventoryIn == this.f_39449_) {
            ItemStack toEnchant = inventoryIn.m_8020_(0);
            gatherStats();
            EnchantingRecipe match = EnchantingRecipe.findItemMatch(world, toEnchant);
            if (toEnchant.m_41613_() == 1 && (match != null || (toEnchant.m_41720_().m_8120_(toEnchant) && isEnchantableEnough(toEnchant)))) {
              float eterna = this.stats.eterna();
              if (eterna < 1.5D)
                eterna = 1.5F; 
              this.f_39451_.m_188584_(this.f_39452_.m_6501_());
              int slot;
              for (slot = 0; slot < 3; slot++) {
                this.f_39446_[slot] = RealEnchantmentHelper.getEnchantmentCost(this.f_39451_, slot, eterna, toEnchant);
                this.f_39447_[slot] = -1;
                this.f_39448_[slot] = -1;
                if (this.f_39446_[slot] < slot + 1)
                  this.f_39446_[slot] = this.f_39446_[slot] + 1; 
                this.f_39446_[slot] = ForgeEventFactory.onEnchantmentLevelSet(world, pos, slot, Math.round(eterna), toEnchant, this.f_39446_[slot]);
              } 
              for (slot = 0; slot < 3; slot++) {
                if (this.f_39446_[slot] > 0) {
                  List<EnchantmentInstance> list = m_39471_(toEnchant, slot, this.f_39446_[slot]);
                  if (list != null && !list.isEmpty()) {
                    EnchantmentInstance enchantmentdata = list.remove(this.f_39451_.m_188503_(list.size()));
                    this.f_39447_[slot] = BuiltInRegistries.f_256876_.m_7447_(enchantmentdata.f_44947_);
                    this.f_39448_[slot] = enchantmentdata.f_44948_;
                    int clues = this.stats.clues();
                    List<EnchantmentInstance> clueList = new ArrayList<>();
                    if (clues-- > 0)
                      clueList.add(enchantmentdata); 
                    while (clues-- > 0 && !list.isEmpty())
                      clueList.add(list.remove(this.f_39451_.m_188503_(list.size()))); 
                    PacketDistro.sendTo(Apotheosis.CHANNEL, new ClueMessage(slot, clueList, list.isEmpty()), this.player);
                  } 
                } 
              } 
              m_38946_();
            } else {
              for (int i = 0; i < 3; i++) {
                this.f_39446_[i] = 0;
                this.f_39447_[i] = -1;
                this.f_39448_[i] = -1;
              } 
              this.stats = TableStats.INVALID;
              PacketDistro.sendTo(Apotheosis.CHANNEL, new StatsMessage(this.stats), this.player);
            } 
          } 
          return this;
        });
  }
  
  private List<EnchantmentInstance> m_39471_(ItemStack stack, int enchantSlot, int level) {
    this.f_39451_.m_188584_((this.f_39452_.m_6501_() + enchantSlot));
    List<EnchantmentInstance> list = RealEnchantmentHelper.selectEnchantment(this.f_39451_, stack, level, this.stats.quanta(), this.stats.arcana(), this.stats.rectification(), this.stats.treasure(), this.stats.blacklist());
    EnchantingRecipe match = ((Optional<EnchantingRecipe>)this.f_39450_.m_6721_((world, pos) -> Optional.ofNullable(EnchantingRecipe.findMatch(world, stack, this.stats.eterna(), this.stats.quanta(), this.stats.arcana()))).get()).orElse(null);
    if (enchantSlot == 2 && match != null) {
      list.clear();
      list.add(new EnchantmentInstance((Enchantment)Ench.Enchantments.INFUSION.get(), 1));
    } 
    return list;
  }
  
  public void gatherStats() {
    this.f_39450_.m_6721_((world, pos) -> {
          this.stats = gatherStats(world, pos, m_38853_(0).m_7993_().getEnchantmentValue());
          PacketDistro.sendTo(Apotheosis.CHANNEL, new StatsMessage(this.stats), this.player);
          return this;
        }).orElse(this);
  }
  
  public static TableStats gatherStats(Level level, BlockPos pos, int itemEnch) {
    TableStats.Builder builder = new TableStats.Builder(itemEnch);
    for (BlockPos offset : EnchantmentTableBlock.f_207902_) {
      if (canReadStatsFrom(level, pos, offset))
        gatherStats(builder, level, pos.m_121955_((Vec3i)offset)); 
    } 
    return builder.build();
  }
  
  public static boolean canReadStatsFrom(Level level, BlockPos tablePos, BlockPos offset) {
    return level.m_8055_(tablePos.m_7918_(offset.m_123341_() / 2, offset.m_123342_(), offset.m_123343_() / 2)).m_204336_(BlockTags.f_278486_);
  }
  
  public static void gatherStats(TableStats.Builder builder, Level world, BlockPos pos) {
    BlockState state = world.m_8055_(pos);
    if (state.m_60795_())
      return; 
    float eterna = EnchantingStatRegistry.getEterna(state, world, pos);
    float max = EnchantingStatRegistry.getMaxEterna(state, world, pos);
    builder.addEterna(eterna, max);
    builder.addQuanta(EnchantingStatRegistry.getQuanta(state, world, pos));
    builder.addArcana(EnchantingStatRegistry.getArcana(state, world, pos));
    builder.addRectification(EnchantingStatRegistry.getQuantaRectification(state, world, pos));
    builder.addClues(EnchantingStatRegistry.getBonusClues(state, world, pos));
    Objects.requireNonNull(builder);
    ((IEnchantingBlock)state.m_60734_()).getBlacklistedEnchantments(state, (LevelReader)world, pos).forEach(builder::blacklistEnchant);
    if (((IEnchantingBlock)state.m_60734_()).allowsTreasure(state, (LevelReader)world, pos))
      builder.setAllowsTreasure(true); 
  }
  
  public MenuType<?> m_6772_() {
    return (MenuType)Apoth.Menus.ENCHANTING_TABLE.get();
  }
  
  public static boolean isEnchantableEnough(ItemStack stack) {
    if (!stack.m_41793_())
      return true; 
    return EnchantmentHelper.m_44831_(stack).keySet().stream().allMatch(Enchantment::m_6589_);
  }
}
